Index: trunk/gui/scripts/field.tcl
===================================================================
--- trunk/gui/scripts/field.tcl	(revision 893)
+++ trunk/gui/scripts/field.tcl	(revision 894)
@@ -203,5 +203,5 @@
     }
     if {[info exists _comp2unirect2d($what)]} {
-	set mobj $_comp2unirect2d($what) 
+        set mobj $_comp2unirect2d($what)
         return [$mobj values]
     }
@@ -228,5 +228,5 @@
     }
     if {[info exists _comp2unirect2d($what)]} {
-	set mobj $_comp2unirect2d($what)
+        set mobj $_comp2unirect2d($what)
         return [$mobj blob]
     }
@@ -503,5 +503,5 @@
         set class [$mobj info class]
         ${class}::release $mobj
-	
+
         set fobj [lindex $_comp2vtk($name) 1]
         rename $fobj ""
@@ -516,5 +516,5 @@
     catch {unset _comp2style}
     array unset _comp2unirect2d
-    
+
     #
     # Scan through the components of the field and create
@@ -523,10 +523,10 @@
     foreach cname [$_field children -type component] {
         set type ""
-        if { ([$_field element $cname.constant] != "" && 
-	      [$_field element $cname.domain] != "") || 
-	     [$_field element $cname.xy] != ""} {
+        if { ([$_field element $cname.constant] != "" &&
+            [$_field element $cname.domain] != "") ||
+            [$_field element $cname.xy] != ""} {
             set type "1D"
-        } elseif {[$_field element $cname.mesh] != "" && 
-		  [$_field element $cname.values] != ""} {
+        } elseif {[$_field element $cname.mesh] != "" &&
+            [$_field element $cname.values] != ""} {
             set type "points-on-mesh"
         } elseif {[$_field element $cname.vtk] != ""} {
@@ -538,5 +538,5 @@
         }
         set _comp2style($cname) ""
-	
+
         if {$type == "1D"} {
             #
@@ -546,5 +546,5 @@
             set xv ""
             set yv ""
-	    
+
             set val [$_field get $cname.constant]
             if {$val != ""} {
@@ -558,9 +558,9 @@
                 set xv [blt::vector create x$_counter]
                 $xv append $z0 $z1
-		
+
                 foreach {val pcomp} [_getValue $val] break
                 set yv [blt::vector create y$_counter]
                 $yv append $val $val
-		
+
                 if {$pcomp != ""} {
                     set zm [expr {0.5*($z0+$z1)}]
@@ -573,5 +573,5 @@
                     set xv [blt::vector create x$_counter]
                     set yv [blt::vector create y$_counter]
-		    
+
                     foreach line [split $xydata \n] {
                         if {[scan $line {%g %g} xval yval] == 2} {
@@ -582,9 +582,9 @@
                 }
             }
-	    
+
             if {$xv != "" && $yv != ""} {
                 # sort x-coords in increasing order
                 $xv sort $yv
-		
+
                 set _comp2dims($cname) "1D"
                 set _comp2xy($cname) [list $xv $yv]
@@ -599,77 +599,77 @@
             set path [$_field get $cname.mesh]
             if {[$_xmlobj element $path] != ""} {
-		set element [$_xmlobj element -as type $path]
-		if { $element == "unirect2d" } {
-		    set _comp2dims($cname) "2D"
-		    set _comp2unirect2d($cname) \
-			[Rappture::UniRect2d \#auto $_xmlobj $_field $cname]
-		    set _comp2style($cname) [$_field get $cname.style]
-		    incr _counter
-		} elseif { $element == "cloud" || $element == "mesh" } {
-		    switch -- $element {
-			cloud {
-			    set mobj [Rappture::Cloud::fetch $_xmlobj $path]
-			}
-			mesh {
-			    set mobj [Rappture::Mesh::fetch $_xmlobj $path]
-			}
-		    }
-		    if {[$mobj dimensions] > 1} {
-			#
-			# 2D/3D data
-			# Store cloud/field as components
-			#
-			set values [$_field get $cname.values]
-			set farray [vtkFloatArray ::vals$_counter]
-			
-			foreach v $values {
-			    if {"" != $_units} {
-				set v [Rappture::Units::convert $v \
-					   -context $_units -to $_units -units off]
-			    }
-			    $farray InsertNextValue $v
-			}
-			
-			set _comp2dims($cname) "[$mobj dimensions]D"
-			set _comp2vtk($cname) [list $mobj $farray]
-			set _comp2style($cname) [$_field get $cname.style]
-			incr _counter
-		    } else {
-			#
-			# OOPS!  This is 1D data
-			# Forget the cloud/field -- store BLT vectors
-			#
-			set xv [blt::vector create x$_counter]
-			set yv [blt::vector create y$_counter]
-			
-			set vtkpts [$mobj points]
-			set max [$vtkpts GetNumberOfPoints]
-			for {set i 0} {$i < $max} {incr i} {
-			    set xval [lindex [$vtkpts GetPoint $i] 0]
-			    $xv append $xval
-			}
-			set class [$mobj info class]
-			${class}::release $mobj
-			
-			set values [$_field get $cname.values]
-			foreach yval $values {
-			    if {"" != $_units} {
-				set yval [Rappture::Units::convert $yval \
-					      -context $_units -to $_units -units off]
-			    }
-			    $yv append $yval
-			}
-			
-			# sort x-coords in increasing order
-			$xv sort $yv
-			
-			set _comp2dims($cname) "1D"
-			set _comp2xy($cname) [list $xv $yv]
-			incr _counter
-		    }
-		}
-	    } else {
-		puts "WARNING: can't find mesh $path for field component"
-	    }
+                set element [$_xmlobj element -as type $path]
+                if { $element == "unirect2d" } {
+                    set _comp2dims($cname) "2D"
+                    set _comp2unirect2d($cname) \
+                        [Rappture::UniRect2d \#auto $_xmlobj $_field $cname]
+                    set _comp2style($cname) [$_field get $cname.style]
+                    incr _counter
+                } elseif { $element == "cloud" || $element == "mesh" } {
+                    switch -- $element {
+                        cloud {
+                            set mobj [Rappture::Cloud::fetch $_xmlobj $path]
+                        }
+                        mesh {
+                            set mobj [Rappture::Mesh::fetch $_xmlobj $path]
+                        }
+                    }
+                    if {[$mobj dimensions] > 1} {
+                        #
+                        # 2D/3D data
+                        # Store cloud/field as components
+                        #
+                        set values [$_field get $cname.values]
+                        set farray [vtkFloatArray ::vals$_counter]
+
+                        foreach v $values {
+                            if {"" != $_units} {
+                                set v [Rappture::Units::convert $v \
+                                   -context $_units -to $_units -units off]
+                            }
+                            $farray InsertNextValue $v
+                        }
+
+                        set _comp2dims($cname) "[$mobj dimensions]D"
+                        set _comp2vtk($cname) [list $mobj $farray]
+                        set _comp2style($cname) [$_field get $cname.style]
+                        incr _counter
+                    } else {
+                        #
+                        # OOPS!  This is 1D data
+                        # Forget the cloud/field -- store BLT vectors
+                        #
+                        set xv [blt::vector create x$_counter]
+                        set yv [blt::vector create y$_counter]
+
+                        set vtkpts [$mobj points]
+                        set max [$vtkpts GetNumberOfPoints]
+                        for {set i 0} {$i < $max} {incr i} {
+                            set xval [lindex [$vtkpts GetPoint $i] 0]
+                            $xv append $xval
+                        }
+                        set class [$mobj info class]
+                        ${class}::release $mobj
+
+                        set values [$_field get $cname.values]
+                        foreach yval $values {
+                            if {"" != $_units} {
+                                set yval [Rappture::Units::convert $yval \
+                                      -context $_units -to $_units -units off]
+                            }
+                            $yv append $yval
+                        }
+
+                        # sort x-coords in increasing order
+                        $xv sort $yv
+
+                        set _comp2dims($cname) "1D"
+                        set _comp2xy($cname) [list $xv $yv]
+                        incr _counter
+                    }
+                }
+            } else {
+                puts "WARNING: can't find mesh $path for field component"
+            }
         } elseif {$type == "vtk"} {
             #
Index: trunk/gui/scripts/nanovisviewer.tcl
===================================================================
--- trunk/gui/scripts/nanovisviewer.tcl	(revision 893)
+++ trunk/gui/scripts/nanovisviewer.tcl	(revision 894)
@@ -112,5 +112,5 @@
     private variable _limits       ;# autoscale min/max for all axes
     private variable _view         ;# view params for 3D view
-	
+
     private variable _isomarkers    ;# array of isosurface level values 0..1
     private common _isosurface     ;# indicates to use isosurface shading
@@ -123,9 +123,9 @@
 
 itcl::class Rappture::NanovisViewer::IsoMarker {
-    private variable _value	"";	# Absolute value of marker.
-    private variable _label	""
-    private variable _tick	""
-    private variable _canvas	""
-    private variable _nvobj	""
+    private variable _value    ""; # Absolute value of marker.
+    private variable _label    ""
+    private variable _tick     ""
+    private variable _canvas   ""
+    private variable _nvobj    ""
     private common _normalIcon ""
     private common _activeIcon ""
@@ -133,10 +133,10 @@
     private variable _active_press    0
 
-    constructor {c obj args} { 
-	set _canvas $c
-	set _nvobj $obj
-	
-	if { $_normalIcon == "" } {
-	    set normal_icon_data {
+    constructor {c obj args} {
+        set _canvas $c
+        set _nvobj $obj
+
+        if { $_normalIcon == "" } {
+            set normal_icon_data {
 R0lGODlhBwATAOcxAAAAAAEBAQICAgMDAwQEBAUFBQYGBgcHBwgICAkJCQoKCgsLCwwMDA0N
 DQ4ODg8PDxAQEBERERISEhMTExQUFBUVFRYWFhcXFxgYGBkZGRoaGhsbGxwcHB0dHR4eHh8f
@@ -156,6 +156,6 @@
 LAAAAAAHABMAAAg2AP8JHEiwoMGDCBFmW0gw259sDR9GhDjQIUWBFidiXPhwYTZTpv6AXBjy
 j0iSJk9+BDnSo8uAADs=
-	    }
-	    set active_icon_data {
+            }
+            set active_icon_data {
 R0lGODlhBwATAOcxAAAAAAEBAQICAgMDAwQEBAUFBQYGBgcHBwgICAkJCQoKCgsLCwwMDA0N
 DQ4ODg8PDxAQEBERERISEhMTExQUFBUVFRYWFhcXFxgYGBkZGRoaGhsbGxwcHB0dHR4eHh8f
@@ -175,122 +175,122 @@
 LAAAAAAHABMAAAg2AP8JHEiwoMGDCBFmW0gwG4BsDR9GhDjQIUWBFidiXPhwYbY/fwCAXBgS
 gEiSJk9+BDnSo8uAADs=
-	    }
-	    set _normalIcon [image create photo -data $normal_icon_data]
-	    set _activeIcon [image create photo -data $active_icon_data]
-	}
-	set w [winfo width $_canvas]
-	set h [winfo height $_canvas]
-	set _tick [$c create image 0 $h \
-		-image $_normalIcon -anchor s \
-		-tags "$this $obj" -state hidden]
-	set _label [$c create text 0 $h \
-		-anchor n -fill white -font "Helvetica 6" \
-		-tags "$this $obj" -state hidden]
-	$c bind $_tick <Enter> [itcl::code $this handle_event "enter"]
-	$c bind $_tick <Leave> [itcl::code $this handle_event "leave"]
-	$c bind $_tick <ButtonPress-1> \
-	    [itcl::code $this handle_event "start" %x %y]
-	$c bind $_tick <B1-Motion> \
-	    [itcl::code $this handle_event "update" %x %y]
-	$c bind $_tick <ButtonRelease-1> \
-	    [itcl::code $this handle_event "end" %x %y]
-    }
-    destructor { 
-	$_canvas delete $this
+            }
+            set _normalIcon [image create photo -data $normal_icon_data]
+            set _activeIcon [image create photo -data $active_icon_data]
+        }
+        set w [winfo width $_canvas]
+        set h [winfo height $_canvas]
+        set _tick [$c create image 0 $h \
+                -image $_normalIcon -anchor s \
+                -tags "$this $obj" -state hidden]
+        set _label [$c create text 0 $h \
+                -anchor n -fill white -font "Helvetica 6" \
+                -tags "$this $obj" -state hidden]
+        $c bind $_tick <Enter> [itcl::code $this handle_event "enter"]
+        $c bind $_tick <Leave> [itcl::code $this handle_event "leave"]
+        $c bind $_tick <ButtonPress-1> \
+            [itcl::code $this handle_event "start" %x %y]
+        $c bind $_tick <B1-Motion> \
+            [itcl::code $this handle_event "update" %x %y]
+        $c bind $_tick <ButtonRelease-1> \
+            [itcl::code $this handle_event "end" %x %y]
+    }
+    destructor {
+        $_canvas delete $this
     }
 
     public method get_absolute_value {} {
-	return $_value
+        return $_value
     }
     public method get_relative_value {} {
-	array set limits [$_nvobj get_limits] 
-	if { $limits(vmax) == $limits(vmin) } {
-	    set limits(vmin) 0.0
-	    set limits(vmax) 1.0
-	}
-	return [expr {($_value-$limits(vmin))/($limits(vmax) - $limits(vmin))}]
+        array set limits [$_nvobj get_limits]
+        if { $limits(vmax) == $limits(vmin) } {
+            set limits(vmin) 0.0
+            set limits(vmax) 1.0
+        }
+        return [expr {($_value-$limits(vmin))/($limits(vmax) - $limits(vmin))}]
     }
     public method activate { bool } {
-	if  { $bool || $_active_press || $_active_motion } {
-	    $_canvas itemconfigure $_label -state normal
-	    $_canvas itemconfigure $_tick -image $_activeIcon
-	} else {
-	    $_canvas itemconfigure $_label -state hidden
-	    $_canvas itemconfigure $_tick -image $_normalIcon
-	}
+        if  { $bool || $_active_press || $_active_motion } {
+            $_canvas itemconfigure $_label -state normal
+            $_canvas itemconfigure $_tick -image $_activeIcon
+        } else {
+            $_canvas itemconfigure $_label -state hidden
+            $_canvas itemconfigure $_tick -image $_normalIcon
+        }
     }
     public method show {} {
-	set_absolute_value $_value
-	$_canvas itemconfigure $_tick -state normal
-	$_canvas raise $_tick
+        set_absolute_value $_value
+        $_canvas itemconfigure $_tick -state normal
+        $_canvas raise $_tick
     }
     public method hide {} {
-	$_canvas itemconfigure $_tick -state hidden
-    }
-    public method get_screen_position { } { 
-	set x [get_relative_value]
-	if { $x < 0.0 } {
-	    set x 0.0
-	} elseif { $x > 1.0 } {
-	    set x 1.0 
-	}
-	set low 10 
-	set w [winfo width $_canvas]
-	set high [expr {$w  - 10}]
-	set x [expr {round($x*($high - $low) + $low)}]
-	return $x
+        $_canvas itemconfigure $_tick -state hidden
+    }
+    public method get_screen_position { } {
+        set x [get_relative_value]
+        if { $x < 0.0 } {
+            set x 0.0
+        } elseif { $x > 1.0 } {
+            set x 1.0
+        }
+        set low 10
+        set w [winfo width $_canvas]
+        set high [expr {$w  - 10}]
+        set x [expr {round($x*($high - $low) + $low)}]
+        return $x
     }
     public method set_absolute_value { x } {
-	set _value $x
-	set y 31
-	$_canvas itemconfigure $_label -text [format %.4g $_value]
-	set x [get_screen_position]
-	$_canvas coords $_tick $x [expr {$y+3}]
-	$_canvas coords $_label $x [expr {$y+5}]
+        set _value $x
+        set y 31
+        $_canvas itemconfigure $_label -text [format %.4g $_value]
+        set x [get_screen_position]
+        $_canvas coords $_tick $x [expr {$y+3}]
+        $_canvas coords $_label $x [expr {$y+5}]
     }
     public method set_relative_value { x } {
-	array set limits [$_nvobj get_limits] 
-	if { $limits(vmax) == $limits(vmin) } {
-	    set limits(vmin) 0.0
-	    set limits(vmax) 1.0
-	}
-	set r [expr $limits(vmax) - $limits(vmin)]
-	set_absolute_value [expr {($x * $r) + $limits(vmin)}]
+        array set limits [$_nvobj get_limits]
+        if { $limits(vmax) == $limits(vmin) } {
+            set limits(vmin) 0.0
+            set limits(vmax) 1.0
+        }
+        set r [expr $limits(vmax) - $limits(vmin)]
+        set_absolute_value [expr {($x * $r) + $limits(vmin)}]
     }
     public method handle_event { option args } {
-	switch -- $option {
-	    enter {
-		set _active_motion 1
-		activate yes
-		$_canvas raise $_tick
-	    }
-	    leave {
-		set _active_motion 0
-		activate no
-	    }
-	    start {
-		$_canvas raise $_tick 
-		set _active_press 1
-		activate yes
-	    }
-	    update {
-		set w [winfo width $_canvas]
-		set x [lindex $args 0]
-		set_relative_value [expr {double($x-10)/($w-20)}]
-		$_nvobj over_isomarker $this $x
-		$_nvobj update_transfer_function
-	    }
-	    end {
-		set x [lindex $args 0]
-		if { ![$_nvobj remove_duplicate_isomarker $this $x]} {
-		    eval handle_event update $args
-		}
-		set _active_press 0
-		activate no
-	    }
-	    default {
-		error "bad option \"$option\": should be start, update, end"
-	    }
-	}
+        switch -- $option {
+            enter {
+                set _active_motion 1
+                activate yes
+                $_canvas raise $_tick
+            }
+            leave {
+                set _active_motion 0
+                activate no
+            }
+            start {
+                $_canvas raise $_tick 
+                set _active_press 1
+                activate yes
+            }
+            update {
+                set w [winfo width $_canvas]
+                set x [lindex $args 0]
+                set_relative_value [expr {double($x-10)/($w-20)}]
+                $_nvobj over_isomarker $this $x
+                $_nvobj update_transfer_function
+            }
+            end {
+                set x [lindex $args 0]
+                if { ![$_nvobj remove_duplicate_isomarker $this $x]} {
+                    eval handle_event update $args
+                }
+                set _active_press 0
+                activate no
+            }
+            default {
+                error "bad option \"$option\": should be start, update, end"
+            }
+        }
     }
 }
Index: trunk/gui/scripts/sequence.tcl
===================================================================
--- trunk/gui/scripts/sequence.tcl	(revision 893)
+++ trunk/gui/scripts/sequence.tcl	(revision 894)
@@ -63,5 +63,5 @@
                     set obj [Rappture::Curve ::#auto $xmlobj $path.$name.$cname]
                 }
-		histogram {
+                histogram {
                     set obj [Rappture::Histogram ::#auto $xmlobj $path.$name.$cname]
                 }
@@ -73,5 +73,5 @@
                 }
                 structure {
-		    # extract unique result set prefix
+                    # extract unique result set prefix
                     scan $xmlobj "::libraryObj%d" rset
 
@@ -79,16 +79,16 @@
                     set obj [$xmlobj element -as object $path.$name.$cname]
 
-		    # scene id (sequence id)
+                    # scene id (sequence id)
                     set sceneid [$xmlobj element -as id $path]-$rset
 
-		    # sequence/element/frame number starting at 1
+                    # sequence/element/frame number starting at 1
                     set frameid [expr [$xmlobj element -as id $path.$name] + 1]
 
-		    # only supporting one molecule per structure at the moment
-		    # otherwise should go through all children that are molecules
-		    # and insert scene/frame data.
+                    # only supporting one molecule per structure at the moment
+                    # otherwise should go through all children that are molecules
+                    # and insert scene/frame data.
                     $obj put "components.molecule.state" $frameid
                     $obj put "components.molecule.model" $sceneid
-		}
+                }
                 default {
                     error "don't know how to handle sequences of $type"